<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruisePromotion ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruisePromotion extends AbstractStructArrayBase
{
    /**
     * The Promotion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruisePromotion[]
     */
    public $Promotion;
    /**
     * Constructor method for ArrayOfJP_CruisePromotion
     * @uses ArrayOfJP_CruisePromotion::setPromotion()
     * @param \StructType\JP_CruisePromotion[] $promotion
     */
    public function __construct(array $promotion = array())
    {
        $this
            ->setPromotion($promotion);
    }
    /**
     * Get Promotion value
     * @return \StructType\JP_CruisePromotion[]|null
     */
    public function getPromotion()
    {
        return $this->Promotion;
    }
    /**
     * This method is responsible for validating the values passed to the setPromotion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPromotion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePromotionForArrayConstraintsFromSetPromotion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruisePromotionPromotionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruisePromotionPromotionItem instanceof \StructType\JP_CruisePromotion) {
                $invalidValues[] = is_object($arrayOfJP_CruisePromotionPromotionItem) ? get_class($arrayOfJP_CruisePromotionPromotionItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruisePromotionPromotionItem), var_export($arrayOfJP_CruisePromotionPromotionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Promotion property can only contain items of type \StructType\JP_CruisePromotion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Promotion value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruisePromotion[] $promotion
     * @return \ArrayType\ArrayOfJP_CruisePromotion
     */
    public function setPromotion(array $promotion = array())
    {
        // validation for constraint: array
        if ('' !== ($promotionArrayErrorMessage = self::validatePromotionForArrayConstraintsFromSetPromotion($promotion))) {
            throw new \InvalidArgumentException($promotionArrayErrorMessage, __LINE__);
        }
        $this->Promotion = $promotion;
        return $this;
    }
    /**
     * Add item to Promotion value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruisePromotion $item
     * @return \ArrayType\ArrayOfJP_CruisePromotion
     */
    public function addToPromotion(\StructType\JP_CruisePromotion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruisePromotion) {
            throw new \InvalidArgumentException(sprintf('The Promotion property can only contain items of type \StructType\JP_CruisePromotion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Promotion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruisePromotion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruisePromotion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruisePromotion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruisePromotion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruisePromotion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Promotion
     */
    public function getAttributeName()
    {
        return 'Promotion';
    }
}
